
;Mit folgendem Code-Grundgerst kann zum Take-5-Programm
;von BlitzMoritz eine eigene knstliche Intelligenz programmiert
;werden, die nach dem Starten mit dem Hauptprogramm von Take 5
;per UDP-Netzwerk kommuniziert.
;Zu entwickeln ist lediglich ein geeigneter Algorithmus in der
;Funktion mit dem Namen 'calculate_best_reaction'

;=================================================

;Der aktuelle Spielzustand wird im Integer-Array map[Spalte,Reihe]
;gespeichert, wobei je 15 Spalten und Reihen von 0 bis 14 laufen.
Dim map%(14,14)
;Bei der Wertbelegung der Positionen gilt (auch im Multiplayer-
;-Modus!) stets  0 = leer, 1 = eigener Stein, 2 = Gegnerstein.

;--------------------------------------------------------------------------------------------

;Mit folgender Function ist (fr 1 = eigener Stein) die nchste Spielzugs-Position zu
;ermitteln und deren Spalte und Reihe dem globalen array 'reaction' zu bergeben
Dim reaction%(1)
;#################################################
Function calculate_best_reaction()
;--------------------------------------------------------------------------------------------



	;Hier kannst du dich nun nach Belieben austoben ...



	;----------------------------------------------------------------
	;WICHTIG ist die finale bergabe (wobei der Zufall hier natrlich Unsinn ist):
	reaction(0) = Rand(0,14)  ;Spalte der ermittelten Position
	reaction(1) = Rand(0,14)  ;Reihe der ermittelten Position
;--------------------------------------------------------------------------------------------
End Function   ;(calculate_best_reaction)
;#################################################


;=================================================
;main loop (please don't change anything):
;=================================================
AppTitle("UDP-Netzwerk")
Graphics 400,300,0,2
SetBuffer BackBuffer()
Global timer= CreateTimer(60)
Global bg% = LoadImage("ExternMiniBackground.jpg")
Repeat
	receive_map()
	calculate_best_reaction()
	send_reaction()
	WaitTimer(timer)
Until KeyDown(1)
;=================================================
Function receive_map()
;=================================================
	Local IP%, Stream = CreateUDPStream(8000)
	If bg <> 0 Then DrawImage bg, 0, 0
	Text 30, 100, "Warten auf aktuelles Spiel ..."
	Text 30, 120, "(Abbrechen mit ESCAPE)"
	Flip
	Repeat
		IP = RecvUDPMsg(Stream)
		If KeyDown(1) Then End
		WaitTimer(timer)
	Until IP <> 0
	For column% = 0 To 14
		For row% = 0 To 14
			map(column, row) = ReadByte(Stream)
		Next
	Next
	CloseUDPStream(Stream)
	Text 30, 160, "Aktueller Spielstand wurde empfangen."
	Text 30,180, "Nun folgt die Berechnung des Spielzuges ..."
	Flip
;=================================================
End Function   ;(receive_map)
;=================================================
Function send_reaction()
;=================================================
	Local Stream = CreateUDPStream()
	Local IP% = IntegerIP("127.0.0.1")
	WriteByte Stream, reaction(0)
	WriteByte Stream, reaction(1)
	SendUDPMsg Stream, IP, 8001
	Text 30, 220, "Spielzug (Spalte " + reaction(0) + ", Reihe " + reaction(1) + ") wird gesendet!"
	Flip
	CloseUDPStream(Stream)
;=================================================
End Function   ;(send_reaction)
;=================================================
Function IntegerIP(IP$)
 A1 = Int(Left(IP$,Instr(IP$,".")-1)) : IP$ = Right(IP$,Len(IP$)-Instr(IP$,"."))
 A2 = Int(Left(IP$,Instr(IP$,".")-1)) : IP$ = Right(IP$,Len(IP$)-Instr(IP$,"."))
 A3 = Int(Left(IP$,Instr(IP$,".")-1)) : IP$ = Right(IP$,Len(IP$)-Instr(IP$,"."))
 A4 = Int(IP$) 
 Return (A1 Shl 24) + (A2 Shl 16) + (A3 Shl 8 ) + A4
End Function
;=================================================