
'Mit folgendem Code-Grundgeruest kann zum Take-5-Programm
'von BlitzMoritz eine eigene kuenstliche Intelligenz programmiert
'werden, die nach dem Starten mit dem Hauptprogramm von Take 5
'per UDP-Netzwerk kommuniziert.
'Zu entwickeln ist lediglich ein geeigneter Algorithmus in der
'Funktion mit dem Namen 'calculate_best_reaction'.

'=================================================
Import Vertex.BNetEx
'=================================================

'Der aktuelle Spielzustand wird im Integer-Array map[Spalte,Reihe]
'gespeichert, wobei je 15 Spalten und Reihen von 0 bis 14 laufen.
Global map%[15,15]   
'Bei der Wertbelegung der Positionen gilt (auch im Multiplayer-
'-Modus!) stets  0 = leer, 1 = eigener Stein, 2 = Gegnerstein.

'--------------------------------------------------------------------------------------------

'Mit folgender Function ist (fuer 1 = eigener Stein) der naechste Spielzug
'zu ermitteln und deren Spalte und Reihe als int-Array zurueckzugeben:
'#################################################
Function calculate_best_reaction:Int[]()
'--------------------------------------------------------------------------------------------



	'Hier kannst du dich nun nach Belieben austoben ...



	Return [Rand(0,14), Rand(0,14)] '(das ist natuerlich noch Unsinn)
'--------------------------------------------------------------------------------------------
End Function   '(calculate_best_reaction)
'#################################################


'=================================================
'main loop (please don't change anything):
'=================================================
AppTitle = "UDP-Netzwerk"
Graphics 400,300
Global reaction%[2], timer:TTImer = CreateTimer(60)
Global bg:TImage = LoadImage("ExternMiniBackground.jpg")
Repeat
	receive_map()
	reaction = calculate_best_reaction()
	If Len(reaction) <> 2 Then
		Notify "Fehler:~nDie Funktion 'calculate_best_reaction' muss die~nSpalte und Reihe des naechsten Spielzuges~nals zweidimensionales int-Array zurueckgeben!~nDas Programm wird beendet!"
		End
	End If
	send_reaction(reaction)
	WaitTimer(timer)
Until KeyDown(KEY_ESCAPE) Or AppTerminate()
'=================================================
Function receive_map:String()
'=================================================
	Local Stream:TUDPStream
	'--------------------------------------
	Try
		Stream = New TUDPStream
		If Not Stream.Init() Then Return "Can't create socket"
		Stream.SetLocalPort(8000)
		If bg <> Null Then DrawImage bg, 0, 0
		DrawText "Warten auf aktuelles Spiel ...", 30, 100
		DrawText "(Abbrechen mit ESCAPE)", 30, 120
		Flip
		Repeat
			If KeyDown(KEY_ESCAPE) Or AppTerminate() Then End
			WaitTimer(timer)
		Until Stream.RecvAvail() 
		While Stream.RecvMsg()
			If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
		Wend
		If Stream.Size() > 0 Then
			For Local column:Int = 0 To 14
				For Local row:Int = 0 To 14
					map[column, row] = Stream.ReadByte()
				Next
			Next
			If Stream Then Stream.Close()
			DrawText "Aktueller Spielstand wurde empfangen.", 30, 160
			DrawText "Nun folgt die Berechnung des Spielzuges ...", 30,180
			Flip
			Return "ok"
		Else
			If Stream Then Stream.Close()
			Return "The map-stream is empty?!"
		End If
	Catch Exception:Object
		Return "Error~n " + Exception.ToString()
	End Try
	If Stream Then Stream.Close()
	Return "Unknown error while receiving map..."
'=================================================
End Function   '(receive_map)
'=================================================
Function send_reaction:String(position:Int[])
'=================================================
	Local Stream:TUDPStream
	Try
		Stream = New TUDPStream
		If Not Stream.Init() Then Return "Can't create socket"
		Stream.SetRemoteIP(TNetwork.IntIP("127.0.0.1"))
		Stream.SetLocalPort()
		Stream.SetRemotePort(8001)
		Stream.WriteByte position[0]
		Stream.WriteByte position[1]
		Stream.SendMsg()
		DrawText "Spielzug (Spalte " + position[0] + ", Reihe " + position[1] + ") wird gesendet!", 30, 220
		Flip
	Catch Exception:Object
		Return "Error~n " + Exception.ToString()
	End Try
	If Stream Then Stream.Close()
	Return "ok"
'=================================================
End Function   '(send_reaction)
'=================================================